#include "LightClass.h"


LightClass::LightClass(void)
	{
	 m_position = D3DXVECTOR4(5.0, 5.0, -3.0,1.0);
	 m_globalAmbient = D3DXVECTOR4(1.0, 1.0, 1.0, 1.0);
	 m_direction = D3DXVECTOR3(-1.0, -1.0, 1.0);

	 m_lightColor = D3DXVECTOR4(1.0, 1.0, 1.0, 1.0);
	 m_shininess = 5.0f;

	 attenuation = D3DXVECTOR4(1.0, 0.0, 0.0, 1.0);
	 spotlight = D3DXVECTOR4(0.7, 0.6, 0.0, 1.0);
	}

LightClass::LightClass(const LightClass & others)
	{

	}

LightClass::~LightClass(void)
	{
	}

void  LightClass::SetLightPosition(float x, float y, float z, float w)
	{
	m_position = D3DXVECTOR4(x, y, z, w);
	}

//ȫֻϵ
void LightClass::SetGlobalAmbient(float red, float green, float blue, float alpha)
	{
	m_globalAmbient = D3DXVECTOR4(red, green, blue, alpha);
	return;
	}

//ƽйⷽ
void LightClass::SetDirection(float x, float y, float z)
	{
	m_direction = D3DXVECTOR3(x, y, z);
	return;
	}

//ùԴɫ
void LightClass:: SetLightColor(float red, float green, float blue, float alpha)
	{
	m_lightColor = D3DXVECTOR4(red, green, blue,alpha);
	return;
	}

//ùԴ˥ϵ
void LightClass:: SetLightAttenuation(float x, float y, float z, float w)
	{
	 attenuation = D3DXVECTOR4(x, y, z,w);
	return;
	}

//̽յƹԴڽֵ
void LightClass:: SetLightSpotLight(float x, float y, float z, float w)
	{
	spotlight = D3DXVECTOR4(x, y, z,w);
	return;
	}

//ȫֻϵ
void LightClass::SetShininess(float shininess)
	{
	m_shininess = shininess;
	return;
	}

//õԴλ
D3DXVECTOR4 LightClass::GetPosition()
	{
	return m_position;
	}

//õȫֻϵ
D3DXVECTOR4 LightClass::GetGlobalAmbient()
	{
	return m_globalAmbient;
	}

//õƽйⷽ
D3DXVECTOR3 LightClass::GetDirection()
	{
	return m_direction; 
	}

//õԴɫ
D3DXVECTOR4 LightClass:: GetLightColor()
	{
	return m_lightColor;
	}

//õȫֻϵ
float LightClass::GetShininess()
	{
	return m_shininess;
	}

//õ˥ϵ
D3DXVECTOR4 LightClass:: GetLightAttenuation()
	{
	return attenuation;
	}

//õspotlightֵ
D3DXVECTOR4 LightClass:: GetSpotLight()
	{
	return spotlight;
	}